! "@(#) $Id: EXTobsinit.prg,v 1.1.1.1 2010-04-19 08:36:39 kbanse Exp $"
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENT      obsinit.prg
!.PURPOSE    Initialize the parameters for the observin
!            batches.
!.USE        @c obsinit
!.AUTHOR     Cristian Levin
!.VERSION    1.0       10/01/95		Creation
!.VERSION    1.1       14/12/97  (PL)	EFOSC2 new values
!.VERSION    1.2       15/08/98  (PL)	VLT + MIDAS 97NOV
!.VERSION    1.3       20/08/04  (EB)   M2 conversion factor and signcorrection because new Unit
!.KEYWORDS
! ------------------------------------------------------
!
write/out " "
write/out "Starting Midas unit 11 ..."
write/out " "

set/midas_system  F_UPDATE=NO PATH=. DPATH=.
@@ EXTsetdisplay

set/format  I1 F8.4
write/key obsmode/C/1/10 	0

! Scale values for the display of the image
write/key ldscale/i/1/2 	-2,-2	!  EFOSC2 binned 2x2

! Instrument scales
write/key imscale/r/1/1		0.120	!  EFOSC2 (old 0.161 ... new 0.155 ?)

! Angle for the rotator offset computation (acquisition frame)
write/key anglerot/i/1/1	0

! Sign for the rotator offset computation (acquisition frame)
write/key signrot/i/1/1	 1	!  EFOSC2

! Rotator angle offset for pointing
write/key ptoffset/r/1/1	-90.0

! Polar angle misalignment
write/key poloff/r/1/1		1.54	! measure 25/12/97

! Max. number of counts in a pixel
write/key maxcts/i/1/1		65000	

! CCD #40 parameters
write/key CCDron/r/1/1		7.97	! in (e-)
write/key CCDgain/r/1/1		1.21	! in (e-/ADU)
write/key CCDbiasF/r/1/1	188.3	! Normal in (ADU)
write/key CCDbias/r/1/1		192	! SLOW in (ADU)

! Focus wedge parameters
! distance between the peers for the wedge focus computation
write/key distwedg/r/1/1	62.0	!  16/08/1998

! Y-shift sign for the wedge focus computation
write/key signwedg/i/1/1 1

! Relation Focus = Const * dY
! EFOSC1	18.0	
! EFOSC2 (2.2m)	 8.6
! EFOSC2 (3.6m newM2 = oldM2*10)  66.0
write/key teloffs/r/1/1	66.0	!  20/08/04
write/key conswedg/r/1/3	48.0,66.0,120.0

!
! camera focus offset constant
write/key camoffs/r/1/1		670	! EFOSC2

! Radius (in pixels) for the circle drawn on "show slit"
write/key radslit/i/1/1		10

! default position angle for pointing
write/key dptangle/r/1/1	270.0	! EFOSC2

! default position Slit length border
write/key slitNORM/r/1/2	290,1780	! Normals
write/key slitMOVE/r/1/2	459,1609	! Movable

! default extraction values for EFOSC2 
write/key extrX/I/1/2 271,1730
write/key extrY/I/1/2 3,2040

! Extracted frame limits EFOSC1
write/key bornX/i/1/2 	100,2000
write/key bornY/i/1/2 	100,2000
!
! read in the reference tables needed
!
set/midas output=no
indisk/fits reference.tfits reference.tbl 
indisk/fits moveReference.tfits moveReference.tbl 
indisk/fits mos.tfits mos.tbl
indisk/fits sky.tfits sky.tbl
indisk/fits thrufocus.tfits thrufocus.tbl
indisk/fits leftWdg.tfits leftWdg.tbl
set/midas output=yes
! 
set/format
$xset b 50 2500 100
write/out " "
write/out "Image Display Scales            : {ldscale(1)},{ldscale(2)} "
write/out "Image Scales        (arcsec/pix): {imscale} "
write/out "Focus constants                 : {conswedg(1)}, {conswedg(2)}, {conswedg(3)}"
write/out "Default Rotator Angle      (deg): {dptangle}"
write/out "Focus Wedge spots distance (pix): {distwedg}"
write/out " "
write/out "Initialisation DONE ..."
write/out " "
!set/back sockets,remote
