!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++           !
!
!.IDENTIFICATION 
!		EXTselect_IQE_stars.prg   P.Le Saux - MAY94
!
!.PURPOSE 	Select objects ( stars or galaxies )
!               to allocate them slits .
!               
!.VERSION
! 940512	creation P.Le Saux
! 111202	last modif
!               
!-----------------------------------------------------------------             !
!
!
!
!                                EMOSELSTAR
!
!		this program looks for stars within a window
!
define/param P1 ?  C  "Enter FITS file full name: "
define/param P2 ?  C  "Enter all objects table name: "

if ididev(10) .ne. 0 clear/chan ov

write/out " inemmi Conversion of {p1} to a.bdf "
   
@@ EXTfits2bdfR90 {p1} 
copy/ii {name} zzzz
write/out " Rotation of {name}.bdf into zzzz "
! 
define/local altitude/r/1/1/ 0.
altitude =   {zzzz.bdf,ESO.TEL.ALT}

if altitude .lt. 10 then 
   write/key outputr/r/1/20  0. all
   write/out "Altitude (= {altitude}) below 10"
   errsum = errsum + 1
   return
endif

read/des zzzz

write/key iscal/i/1/1 -2

iscal = m$nint(-4. / {zzzz.bdf,STEP(1)})

stat/ima zzzz
write/keyw rcorr -
0,65535,954.731,1182.76,41.0943,1954.89,1.01287e+09,918,128.5 
@@ kcompare sele010:rcorr outputr 1,2 0.05 3,6 0.01 8,9 0.05

define/local lowcut/r/1/1 1000.
define/local upcut/r/1/1  1200.
lowcut = 1.2 * outputr(3)
upcut  = 1.5 * outputr(3)

if lowcut .lt. 1000. then
   load zzzz cuts=1000,1200 scale={iscal}
else 
   load zzzz cuts={outputr(3)},{upcut} scale={iscal}
endif 

write/key objets/i/1/1 1
write/key threshld/i/1/1 30
write/key adda/r/1/1 1
write/key col/i/1/1 2
write/key logoff/i/1/1 0

! define subframe where to scan for objects

write/out


! extract subframe for inventory .

copy/ii {idimemc} extract_ima 

stat/ima extract_ima
write/keyw rcorr -
0,65535,954.731,1182.76,41.0943,1954.89,1.01287e+09,918 ,128.5
@@ kcompare sele020:rcorr outputr 1,2 0.05 3,6 0.01 8,9 0.05

! INVENTORY

set/context invent

inv_real(3) = 'threshld'
inv_real(10) = {{idimemc},o_time(7)}
inv_real(42) = 15
inv_real(43) = 15
copy/dk extract_ima statistic/r/8/1 inv_real/r/1/1
copy/dk extract_ima statistic/r/2/1 inv_real/r/2/1

read/key inv_intg
read/key inv_real

log(4) = 0

search/inventory extract_ima transfert
stat/table transfert :bg
read/tab transfert :bg @1..10

analyse/inventory extract_ima transfert trsfrt
classify/inventory trsfrt

statistics/table trsfrt :rad_iso >Null
write/keyw rcorr 0.8892932,20.00000,5.1300197,3.2878
@@ kcompare sele030:rcorr outputr 1,1 0.005 2,4 0.005
statistics/table trsfrt :mag_iso >Null
write/keyw rcorr   7.526601,20.0127,16.179331,2.4473119
@@ kcompare sele040:rcorr outputr 1,1 0.0005 2,3 0.005 4,4 0.0005
rcorr = 0.1555
outputr = {trsfrt.tbl,:elong,@12}
@@ kcompare sele050:rcorr outputr 1,1 0.0001

del/tab tabinv no
create/tab tabinv {trsfrt.tbl,tblcontr(3)} {trsfrt.tbl,tblcontr(4)} NULL

copy/tt trsfrt :ident tabinv :ident
copy/tt trsfrt :x tabinv :x
copy/tt trsfrt :y tabinv :y
copy/tt trsfrt :MAG_ISO tabinv :int
copy/tt trsfrt :class tabinv :class

if outputi(1) .eq. 0 then
  write/key outputr/r/1/20  0. all
  write/out "No objects found"
  errsum = errsum + 1
  return
endif

! draw found objects

copy/tab tabinv bof

name/col bof :ident range F6.0
name/col bof :x "" F12.5
name/col bof :y "" F12.5
name/col bof :int "" F12.5
name/col bof :class "" F6.0

load/tab bof :x :y ? 0 3 6

!	sort by magnitudes

sort/tab bof :int

stat/table bof :x
write/keyw rcorr 9.74183,2031.0,1003.255,597.0604
@@ kcompare sele035:rcorr outputr 1,4 0.005
stat/table bof :y
write/keyw rcorr  20.1351,2052.825,1046.059,617.803
@@ kcompare sele036:rcorr outputr 1,4 0.005
stat/table bof :int
write/keyw rcorr 7.52660,20.0116,16.17899,2.447365
@@ kcompare sele037:rcorr outputr 1,4 0.005
stat/table bof :class
if mid$verif(1:3) .eq. "NEW" then
   write/keyw rcorr 0.0,2.0,1.1271186,0.7322588
else
   write/keyw rcorr 0.0,2.0,1.1214689,0.7332199
endif


! PBA-REF-TEST-2015-02: @@ kcompare sele038:rcorr outputr 1,4 0.005
@@ kcompare sele038:rcorr outputr 1,4 0.01

compute/tab bof :xstart = :x - 20
compute/tab bof :xend   = :x + 20
compute/tab bof :ystart = :y - 20
compute/tab bof :yend   = :y + 20

write/out
write/out "end INVENTORY"
write/out

select/tab bof :xstart .gt. 5
outputi(4) = outputi(1)
select/tab bof select .and. :ystart .gt. 5
outputi(3) = outputi(1)
select/tab bof select .and. :xend   .lt. 2055
outputi(2) = outputi(1)
select/tab bof select .and. :yend   .lt. 2055
write/keyw icorr 336,345,345,347
@@ kcompare sele060:icorr outputi 1,4
! 
if outputi(1) .lt. 10 then
  write/out
  write/out
  write/out
  write/out
  write/out "only {outputi(1)} objects found in {P1}"
endif
copy/tab bof baf
read/tab baf @130,131,132,133

copy/tab baf bof
name/col bof :xstart "" F8.2
name/col bof :ystart "" F8.2
name/col bof :xend   "" F8.2
name/col bof :yend   "" F8.2

write/out "center/IQE {idimemc},bof bof" 
center/IQE {idimemc},bof bof >Null

statistics/table bof :angle 
if mid$verif(1:3) .eq. "NEW" then
   write/keyw rcorr  0.8074135,178.4324,85.74820,41.9783
else
   write/keyw rcorr  0.8074135,178.4324,89.771446,42.439167
endif

! PBA-REF-TEST-2015-02: @@ kcompare sele070:rcorr outputr 1,1 0.00001 2,2 0.005 3,4 0.0001
@@ kcompare sele070:rcorr outputr 1,1 0.1 2,2 0.005 3,4  10.0

! 
name/col bof :XERR   "" F7.3
name/col bof :YERR   "" F7.3
name/col bof :XSIG   "" F7.3
name/col bof :YSIG   "" F7.3
name/col bof :STATUS   "" F7.0
name/col bof :ANGLE_SIG   "" F8.2

name/col bof :xcen "" F8.2
name/col bof :ycen "" F8.2
name/col bof :AX_MAJ :xfwhm "" F8.3
name/col bof :AX_MIN :yfwhm "" F8.3
name/col bof :icent "" F10.0
compute/tab bof :xseeing = 0.12 * :xfwhm
compute/tab bof :yseeing = 0.12 * :yfwhm 
name/col bof :xseeing "arcsec" F8.3
name/col bof :yseeing "arcsec" F8.3
name/col bof :angle   "degrees" F5.0
statistics/image {idimemc} [500,500:1500,1500]
write/keyw rcorr -
 530,65535,961.094,941.237,46.1503,2568.56,2.41236e+08,920,912.382  
@@ kcompare sele080:rcorr outputr 1,2 0.05 3,6 0.01 8,9 0.05

compute/tab bof :intens = :icent - {outputr(3)}
!read/tab bof :xcen :ycen :xseeing :yseeing :intens :int
select/tab bof :y .lt.767 .or. :y .gt. 771
select/tab bof SELECT .and. :icent .le. 50000. .and. :intens .ge. 1000
select/tab bof SELECT .and. :xseeing .ge. 0.25 .and. :yseeing.ge. 0.25
copy/tab bof baf
copy/tab baf bof
!read/tab bof :xcen :ycen :xseeing :yseeing :intens :int
clear/channel overlay
load/tab bof :xcen :ycen ? 1 6 3
sort/tab bof :intens

set/format f8.3
compute/tab bof :long = :xseeing / :yseeing
name/col bof :long   "" F8.2

set/format F8.3

recom:
write/key nelements/i/1/1 {bof.tbl,tblcontr(4)}
select/tab bof :long .ge. 1.
stat/tab bof :long >Null

write/key elong/r/1/2 {outputr(3)},{outputr(4)}   
stat/tab bof :angle >Null

write/key angle/r/1/2 {outputr(3)},{outputr(4)}   
select/tab bof all

stat/tab bof :xseeing >Null
write/out " seeing along X {outputr(3)}   sigma {outputr(4)}"
write/key seex/r/1/2 {outputr(3)},{outputr(4)}   
write/out
write/out

stat/tab bof :yseeing >Null
write/out " seeing along Y {outputr(3)}   sigma {outputr(4)}"
write/key seey/r/1/2 {outputr(3)},{outputr(4)}   
write/out
write/out

set/format f8.3
write/key sigmax/r/1/1 {seex(2)}
write/key sigmay/r/1/1 {seey(2)}
write/key critx/r/1/1 0
critx = 1.8 * seex(2)
write/key crity/r/1/1 0
crity = 1.8 * seey(2)

compute/tab bof :dseex = abs(:xseeing - {seex(1)})
compute/tab bof :dseey = abs(:yseeing - {seey(1)})

!compute/tab bof :dseex = sqrt((:xseeing - {seex(1)})**2)
!compute/tab bof :dseey = sqrt((:yseeing - {seey(1)})**2)

name/col bof :dseex "pix." F6.3
name/col bof :dseey "pix." F6.3
name/col bof :intens "pix." F7.0

select/tab bof :dseex .lt. {critx} .and. :dseey .lt. {crity}

copy/tab bof baf
copy/tab baf bof
write/out "selected {outputi(1)} of {nelements} le than {critx} {crity}"

if {nelements} .gt. {outputi(1)} goto recom



load/tab bof :xcen :ycen ? 1 7 8
load/tab bof :xcen :ycen ? 1 6 5


outputr(1) = seex(1)
outputr(2) = seex(2)
outputr(3) = seey(1)
outputr(4) = seey(2)


write/key rcorr  1.083,0.031,1.007,0.038 
@@ kcompare sele088:rcorr outputr 1,4 0.005 

create/tab efsee 50 1
create/col efsee :date "years"   F9.3 R*4
create/col efsee :obs1 "s"       A20  C*20
create/col efsee :air1  ?        F6.2 R*4
create/col efsee :air2  ?        F6.2 R*4
create/col efsee :time "s"       F8.1 R*4
create/col efsee :binx "pix."    I4  
create/col efsee :filt " "       A20  C*20
create/col efsee :see1 "\""      F6.2 R*4
create/col efsee :see2 "\""      F6.2 R*4
create/col efsee :rhum "%"       F6.0 R*4
create/col efsee :temp "C"       F6.2 R*4
create/col efsee :pres "mb"      F6.0 R*4
create/col efsee :wdir " "       F6.0 R*4
create/col efsee :wspd "m/s"     F6.1 R*4
create/col efsee :azim " "       F6.1 R*4
create/col efsee :alti " "       F6.1 R*4
create/col efsee :fcus "mm"      F8.2 R*4
create/col efsee :alfa " "       F9.2 R*8
create/col efsee :dlta " "       F9.2 R*8
create/col efsee :tefo "K"       F8.2 R*8
create/col efsee :xsee "\""      F6.3 R*4
create/col efsee :ysee "\""      F6.3 R*4
create/col efsee :xseg "\""      F6.3 R*4
create/col efsee :yseg "\""      F6.3 R*4
create/col efsee :jour "days"    F14.6 R*8
create/col efsee :angle "deg."   F5.0 R*4
create/col efsee :ang_sig "deg." F5.0 R*4
create/col efsee :long " "       F6.2 R*4
create/col efsee :long_sig " "   F6.2 R*4

compute/table efsee :date =   {zzzz.bdf,DATE}
compute/table efsee :obs1 =   "{zzzz.bdf,ESO.OBS.START}"
compute/table efsee :air1 =   {zzzz.bdf,ESO.TEL.AIRM.START}
compute/table efsee :air2 =   {zzzz.bdf,ESO.TEL.AIRM.END}
compute/table efsee :time =   {zzzz.bdf,ESO.DET.WIN1.UIT1}
compute/table efsee :binx =   {zzzz.bdf,ESO.DET.WIN1.BINX}
compute/table efsee :filt =   "{zzzz.bdf,ESO.INS.FILT1.NAME}"
compute/table efsee :see1 =   {zzzz.bdf,ESO.TEL.AMBI.FWHM.START}
compute/table efsee :see2 =   {zzzz.bdf,ESO.TEL.AMBI.FWHM.END}
compute/table efsee :rhum =   {zzzz.bdf,ESO.TEL.AMBI.RHUM}
compute/table efsee :temp =   {zzzz.bdf,ESO.TEL.AMBI.TEMP}
compute/table efsee :pres =   {zzzz.bdf,ESO.TEL.AMBI.PRES.END}
compute/table efsee :wdir =   {zzzz.bdf,ESO.TEL.AMBI.WINDDIR}
compute/table efsee :wspd =   {zzzz.bdf,ESO.TEL.AMBI.WINDSP}
compute/table efsee :azim =   {zzzz.bdf,ESO.TEL.AZ}

compute/table efsee :alti =   {zzzz.bdf,ESO.TEL.ALT}
compute/table efsee :fcus =   {zzzz.bdf,ESO.TEL.FOCU.VALUE}
compute/table efsee :alfa =   {zzzz.bdf,ESO.TEL.TARG.ALPHA}
compute/table efsee :dlta =   {zzzz.bdf,ESO.TEL.TARG.DELTA}

create/col bof :date "years"   F9.3 R*4
create/col bof :obs1 "s"       A20  C*20
create/col bof :air1  ?        F6.2 R*4
create/col bof :air2  ?        F6.2 R*4
create/col bof :time "s"       F8.1 R*4
create/col bof :binx "pix."    I4  
create/col bof :filt " "       A20  C*20
create/col bof :see1 "\""      F6.2 R*4
create/col bof :see2 "\""      F6.2 R*4
create/col bof :rhum "%"       F6.0 R*4
create/col bof :temp "C"       F6.2 R*4
create/col bof :pres "mb"      F6.0 R*4
create/col bof :wdir " "       F6.0 R*4
create/col bof :wspd "m/s"     F6.1 R*4
create/col bof :azim " "       F6.1 R*4
create/col bof :alti " "       F6.1 R*4
create/col bof :fcus "mm"      F8.2 R*4
create/col bof :alfa " "       F9.2 R*8
create/col bof :dlta " "       F9.2 R*8
create/col bof :tefo "K"       F8.2 R*8
create/col bof :jour "days"    F12.3 R*8

compute/table bof :date =   {zzzz.bdf,DATE}
compute/table bof :obs1 =   "{zzzz.bdf,ESO.OBS.START}"
compute/table bof :air1 =   {zzzz.bdf,ESO.TEL.AIRM.START}
compute/table bof :air2 =   {zzzz.bdf,ESO.TEL.AIRM.END}
compute/table bof :time =   {zzzz.bdf,ESO.DET.WIN1.UIT1}
compute/table bof :binx =   {zzzz.bdf,ESO.DET.WIN1.BINX}
compute/table bof :filt =   "{zzzz.bdf,ESO.INS.FILT1.NAME}"
compute/table bof :see1 =   {zzzz.bdf,ESO.TEL.AMBI.FWHM.START}
compute/table bof :see2 =   {zzzz.bdf,ESO.TEL.AMBI.FWHM.END}
compute/table bof :rhum =   {zzzz.bdf,ESO.TEL.AMBI.RHUM}
compute/table bof :temp =   {zzzz.bdf,ESO.TEL.AMBI.TEMP}
compute/table bof :pres =   {zzzz.bdf,ESO.TEL.AMBI.PRES.END}
compute/table bof :wdir =   {zzzz.bdf,ESO.TEL.AMBI.WINDDIR}
compute/table bof :wspd =   {zzzz.bdf,ESO.TEL.AMBI.WINDSP}
compute/table bof :azim =   {zzzz.bdf,ESO.TEL.AZ}
compute/table bof :alti =   {zzzz.bdf,ESO.TEL.ALT}
compute/table bof :fcus =   {zzzz.bdf,ESO.TEL.FOCU.VALUE}
compute/table bof :alfa =   {zzzz.bdf,ESO.TEL.TARG.ALPHA}
compute/table bof :dlta =   {zzzz.bdf,ESO.TEL.TARG.DELTA}

write/key existTemp/i/1/1
existTemp = M$EXISTD("zzzz.bdf","ESO.TEL.TSS.TEMP8")
if {existTemp} .eq. 1 then
  compute/table efsee :tefo =   {zzzz.bdf,ESO.TEL.TSS.TEMP8}  
  compute/table bof   :tefo =   {zzzz.bdf,ESO.TEL.TSS.TEMP8}
else
  compute/table efsee :tefo =   -273.15
  compute/table bof   :tefo =   -273.15
endif

compute/table efsee :xsee =   {outputr(1)}
compute/table efsee :xseg =   {outputr(2)}
compute/table efsee :ysee =   {outputr(3)}
compute/table efsee :yseg =   {outputr(4)}
compute/table efsee :angle =  {angle(1)}
compute/table efsee :ang_sig = {angle(2)}
compute/table efsee :long    = {elong(1)}
compute/table efsee :long_sig    = {elong(2)}
! 
compute/table efsee :nsee =   {bof.tbl,tblcontr(10)}
write/key ngood/i/1/1 {bof.tbl,tblcontr(10)}
outputr(5) = 1. * {ngood}

 set/format f15.7
 write/key obs/c/1/20 {efsee,:obs1,@1}
 read/k obs
 write/key year/i/1/1 'obs(1:4)'
 write/key month/i/1/1 'obs(6:7)'
 write/key day/i/1/1 'obs(9:10)'

 write/key hour/i/1/1 'obs(12:13)'
 write/key minute/i/1/1 'obs(15:16)'
 write/key seconds/i/1/1 'obs(18:19)'
 write/key heure/d/1/1 0
 write/key jour/d/1/1 0
 jour = (year - 2001.) * 365. + month * 30. + day
 heure = (hour * 3600. + minute * 60. + seconds) / 86400.
 jour = jour + heure
 write/out
 write/out "jour: {jour}"
 write/out
 compute/tab efsee :jour = {jour}
 compute/tab bof   :jour = {jour}
 read/tab efsee
 if mid$verif(1:3) .eq. "NEW" then
    write/keyw rcorr -
    1.084,0.031,1.008,0.038,47,2568.56,2.41236e+08,920,912.382 
 else
    write/keyw rcorr -
    1.083,0.031,1.007,0.038,47,2568.56,2.41236e+08,920,912.382 
 endif
 @@ kcompare sele090:rcorr outputr 1,4 0.001 6,6 0.01 8,9 0.005

 stat/tab efsee :xsee  >Null
 if mid$verif(1:3) .eq. "NEW" then
    write/keyw rcorr 1.084000,1.084000,1.0839999,0.0000000
 else 
    write/keyw rcorr 1.083000,1.083000,1.0829999,0.0000000
 endif
 @@ kcompare sele091:rcorr outputr 1,4 0.0001 
 stat/tab efsee :ysee  >Null
 if mid$verif(1:3) .eq. "NEW" then
    write/keyw rcorr 1.008000,1.008000,1.0080000,0.0000000
 else
    write/keyw rcorr 1.007000,1.007000,1.0070000,0.0000000
 endif
 @@ kcompare sele092:rcorr outputr 1,4 0.0001 
 stat/tab efsee :nsee  >Null
 if mid$verif(1:3) .eq. "NEW" then
    write/keyw rcorr 46.000,46.00,46.000,0.00
 else
    write/keyw rcorr 47.000,47.00,47.000,0.00
 endif
 @@ kcompare sele092:rcorr outputr 1,4 0.0001 


if {bof.tbl,tblcontr(4)} .ge. 1 then
 if m$exist("seeing.tbl") .eq. 1 then
	merge/table seeing efsee temp
	copy/table temp seeing
        sort/tab seeing :obs1
 else
	copy/table efsee seeing
 endif

endif


 if m$exist("{P2}.tbl") .eq. 1 then
	merge/table {P2} bof temp
	copy/table temp {P2}
        sort/tab {P2} :jour
 else
	copy/table bof {P2}
 endif




